//+------------------------------------------------------------------+
//|                                                    CandyD1H4.mq4 |
//|                                                    .. |
//|                                              shestovav@gmail.com |
//+------------------------------------------------------------------+
#property copyright ".."
#property link      "shestovav@gmail.com"

#include <stdlib.mqh>

extern double  Profit   = 1000;
extern double  SLoss    = 100;
extern double  Lot      = 0.01;
extern int     Strategy = 4;//  (1-   H4; 2-   H4; 3-   D1   H4; 4-   D1   H4)
extern int     BU       = 0;
extern double  BUenter  = 200;
extern double  BUstop   = 10;


int Type,Ticket;
double SL,TP,OpenPrise,EnterBU,StopLossBU,Stop,StopLevel,Enter;
bool CheckBU;

int init(){
   Profit*=Point; 
   SLoss*=Point; 
   BUenter*=Point;
   BUstop*=Point;
return(0);
}

int deinit() {
return(0);
}

int start() {
   if(!WorkOrders()){                                       //  
      StopLevel=Point*MarketInfo(Symbol(),MODE_STOPLEVEL);  //   //Point*
      UpTrend();     // 
      DownTrend();   // 
   }
      
   if(WorkOrders()){                                     //  
      if ((BU==1)&&(Type<=1)&&(!CheckBU)) SetBU();
      if (Type==1)                           UpTrend();
      if (Type==0)                           DownTrend();
      if (Type==5)                           DownCloseH4(); //    
      if (Type==4)                           UpCloseH4();   //    
   }

return(0);
}

//-------    
void UpTrend(){
   if(Strategy==4){
      if((iOpen(NULL,PERIOD_D1,1)-iClose(NULL,PERIOD_D1,1)<0)&&
         (iOpen(NULL,PERIOD_H4,2)-iClose(NULL,PERIOD_H4,2)>0)&&
         (iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)<0)) By();}
   if(Strategy==3){
      if((iOpen(NULL,PERIOD_D1,1)-iClose(NULL,PERIOD_D1,1)<0)&&
         (iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)<0)) By();}
   if(Strategy==2){
      if((iOpen(NULL,PERIOD_H4,2)-iClose(NULL,PERIOD_H4,2)>0)&&
         (iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)<0)) By();}
   if(Strategy==1){
      if(iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)<0) By();}
}
     
void DownTrend(){
   if(Strategy==4){
      if((iOpen(NULL,PERIOD_D1,1)-iClose(NULL,PERIOD_D1,1)>0)&&
         (iOpen(NULL,PERIOD_H4,2)-iClose(NULL,PERIOD_H4,2)<0)&&
         (iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)>0)) Sell();}
   if(Strategy==3){
      if((iOpen(NULL,PERIOD_D1,1)-iClose(NULL,PERIOD_D1,1)>0)&&
         (iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)>0)) Sell();}
   if(Strategy==2){
      if((iOpen(NULL,PERIOD_H4,2)-iClose(NULL,PERIOD_H4,2)<0)&&
         (iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)>0)) Sell();}
   if(Strategy==1){
      if (iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)>0) Sell();}
}

//-------     
void Sell(){
      Enter=iLow(NULL,PERIOD_H4,1)-10*Point;
      SL=Enter+SLoss;
      TP=Enter-Profit;
      if(IsTradeAllowed()){
         DellAllOrders();
         if(Bid-Enter>=StopLevel-0.5*Point){
            OrderSend(Symbol(),OP_SELLSTOP,Lot,Enter,0,SL,TP,0,0,0,Green);}
         else
            if(Bid==Enter) OrderSend(Symbol(),OP_SELL,Lot,Enter,0,SL,TP,0,0,0,Green);
      }
      else Sleep(1000);
}

void By(){
      Enter=iHigh(NULL,PERIOD_H4,1)+(Ask-Bid)+10*Point;
      SL=Enter-SLoss;
      TP=Enter+Profit;
      if(IsTradeAllowed()){
         DellAllOrders();
         if(Enter-Ask>=StopLevel-0.5*Point){
            OrderSend(Symbol(),OP_BUYSTOP,Lot,Enter,0,SL,TP,0,0,0,Green);}
         else 
            if(Ask==Enter) OrderSend(Symbol(),OP_BUY,Lot,Enter,0,SL,TP,0,0,0,Green);
      }
      else Sleep(1000);
}

//-------   H4
void DownCloseH4(){
     if((iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)<0)&&(IsTradeAllowed())) DellAllOrders();}

void UpCloseH4(){
     if((iOpen(NULL,PERIOD_H4,1)-iClose(NULL,PERIOD_H4,1)>0)&&(IsTradeAllowed())) DellAllOrders();}


//-------   
void SetBU(){
      if(Type==0){
         EnterBU=OpenPrise+BUenter;
         StopLossBU=OpenPrise+BUstop;
         RefreshRates();
         if(Bid>=EnterBU) OrderModify(Ticket,OpenPrise,StopLossBU,OrderTakeProfit(),0,Red);
      }
      if(Type==1){
         EnterBU=OpenPrise-BUenter;
         StopLossBU=OpenPrise-BUstop;
         RefreshRates();
         if(Ask<=EnterBU) OrderModify(Ticket,OpenPrise,StopLossBU,OrderTakeProfit(),0,Red);
      }
}
   
//------- ,   
void DellAllOrders(){
      if(WorkOrders()){
      if(Type<=1)OrderClose(Ticket,OrderLots(),OrderClosePrice(),10);
      else OrderDelete(Ticket);}
}
  
//-------   
bool WorkOrders(){
      for (int i=OrdersTotal()-1;i>=0;i--){
      if (!OrderSelect(i,SELECT_BY_POS))  continue;
      if (OrderSymbol()!=Symbol())        continue;
      OpenPrise=OrderOpenPrice();
      Type     =OrderType();
      Ticket   =OrderTicket();
      Stop     =OrderStopLoss();
      CheckBU  =false;
      if(Type==0 && Stop>OpenPrise) CheckBU=true;
      if(Type==1 && Stop<OpenPrise) CheckBU=true;
      return(true);}
return(false);
}